.TH RD 1 "17 January 2002"
.SH NAME
rd, rm\- Register manipulation commands
.SH SYNOPSIS
rd [c|d|u]
.LP
rm \fIregister-name\fP \fInew-contents\fP
.LP
ef <address>
.SH DESCRIPTION
The
.B rd 
command is used to display the contents of processor registers.
Without any arguments, the rd command displays the contents of
the general register set at the point at which the kernel debugger
was entered.
.P
With the 'c' argument, the processor control registers
%cr0, %cr1, %cr2 and %cr4 are displayed, while with the 'd' argument
the processor debug registers are displayed.  If the 'u' argument
is supplied, the registers for the current task as of the last
time the current task entered the kernel are displayed.
.P
On ix86, the
.B rm
command allows modification of a register.  The following 
register names are valid:  \fB%eax\fP, \fB%ebx\fP, \fB%ecx\fP,
\fB%edx\fP, \fB%esi\fP, \fB%edi\fP, \fB%esp\fP, \fB%eip\fP, 
and \fB%ebp\fP.   Note that if two '%' symbols are used 
consecutively, the register set displayed by the 'u' argument
to the \fBrd\fP command is modified.
.P
The debug registers, \fBdr0\fP through \fBdr3\fP and both
\fBdr6\fP and \fBdr7\fP can also be modified with the \fBrm\fP
command.
.P
On sparc64, the valid registers are named \fB%g0\fP through
\fB%g7\fP, \fB%l0\fP through \fB%l7\fP, \fB%o0\fP through
\fB%o7\fP, and \fB%i0\fP through \fB%i7\fP, with the exceptions
that \fB%o6\fP is called \fB%sp\fP and that \fB%i6\fP is called
\fB%fp\fP. The registers \fB%tstate\fP, \fB%tpc\fP, \fB%tnpc\fP,
\fB%y\fP, and \fB%fprs\fP provide state information at the time
the system entered kdb. Additionally, when viewing registers, two
convenience names are provided: \fB%&regs\fP shows the
address on the stack of the current registers, and \fB%csp\fP
shows the current stack pointer within kdb itself.
.P
The
.B ef
command displays an exception frame at the specified address.
.SH LIMITATIONS
Currently the \fBrm\fP command will not allow modification of the
control registers.
.P
Currently neither the \fBrd\fP command nor the \fBrm\fP command will
display or modify the model specific registers on the Pentium
and Pentium Pro families.
.SH ENVIRONMENT
None.
.SH SMP CONSIDERATIONS
None.
.SH EXAMPLES
.TP 8
rd
Display general register set.

.TP 8
rm %eax 0
Set the contents of \fB%eax\fP to zero.  This will be the
value of %eax when kdb returns from the condition which 
invoked it.

.TP 8
rm %%eax 0
Set the value of the \fB%eax\fP register to zero.  This will
be the value the user-mode application will see upon returning
from the kernel.

.TP 8
rm dr0 0xc1287220
Set the value of the \fBdr0\fB register to \f(CW0xc1287220\fP.
